<template>
    <div class="bar">
        <input @input="Search" v-model="searchTerm" placeholder="Search for template or groups" class="search">
        <select @change="Search" class="search-type" v-model="type">
            <option selected>Template</option>
            <option>Group</option>
        </select>
    </div>

</template>

<style lang='scss' scoped>
    .bar {
        position: relative;
        display: flex;
        align-items: center;
    }

    .search-type, .search {
        height: 30px;
        margin: 0;
        padding: 0;
        border: none;
        box-sizing: border-box;
    }

    .search {
        width: 250px;
        padding: 10px;
        font-size: 14px;
        font-family: Quicksand, sans-serif;
        border-radius: 5px 0 0 5px;
        border-style: solid;
        border-width: 1px 0 1px 1px;
    }

    .search-type {
        border-radius: 0 5px 5px 0;
        border-style: solid;
        border-width: 1px 1px 1px 0;
    }

</style>

<script lang='ts'>
	import {Component, Vue, Watch} from 'vue-property-decorator';
	
	@Component({})
	export default class SearchBar extends Vue {
		private searchTerm?: string;
		private type?: string;
		private previous?: string;

		data() {
			return {
				searchTerm: "",
				type: "",
				previous: "",
			}
		}

		@Watch('$route', {immediate: true, deep: true})
		onUrlChange() {
			this.previous = this.type || "Template";
			this.type = this.$route.params.type || this.previous;
			this.searchTerm = this.$route.params.id;
		}

		async Search() {
			this.$router.push({path: `/search/${this.type!}/${this.searchTerm! || ""}`});
		}
	}
</script>
